﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace PIbd_21_Potapov_N.S._Catamaran_Base
{
    public partial class Form : System.Windows.Forms.Form
    {
        DrawCatamaran catamaranDrawObj;

        public Form()
        {
            InitializeComponent();
            pictureBox.Image = new Bitmap(pictureBox.Width, pictureBox.Height);
        }

        private void btn_new_Click(object sender, EventArgs e)
        {
            Random rnd = new Random();    

            catamaranDrawObj = new DrawCatamaran();
            catamaranDrawObj.Init(rnd.Next(50, 100), Color.FromArgb(rnd.Next(0, 255), rnd.Next(0, 255), rnd.Next(0, 255)), Directions.Right, 20);
            catamaranDrawObj.SetPosition(rnd.Next(10, 50), rnd.Next(10, 50), pictureBox.Width, pictureBox.Height);
            toolStripStatusLabelSpeed.Text = $"Скорость: {catamaranDrawObj.Catamaran.Speed}";
            toolStripStatusLabelWeight.Text = $"Вес: {catamaranDrawObj.Catamaran.Weight}";
            toolStripStatusLabelColor.Text = $"Цвет: {catamaranDrawObj.Catamaran.EntityColor.Name}";
            RedrawCatamaran();
        }

        private void btn_move_Click(object sender, EventArgs e)
        {
            if (catamaranDrawObj == null)
                return;

            string btnName = ((Button)sender).Name;

            switch (btnName)
            {
                case "btn_up":
                    {
                        catamaranDrawObj.MoveTransport(Directions.Up);
                    }
                break;
                case "btn_down":
                    {
                        catamaranDrawObj.MoveTransport(Directions.Down);
                    }
                break;
                case "btn_left":
                    {
                        catamaranDrawObj.MoveTransport(Directions.Left);
                    }
                break;
                case "btn_right":
                    {
                        catamaranDrawObj.MoveTransport(Directions.Right);
                    }
                break;
                default:
                    break;
            }
            RedrawCatamaran();
        }

        private void RedrawCatamaran()
        {
            Graphics g = Graphics.FromImage(pictureBox.Image);
            g.Clear(Color.White);
            catamaranDrawObj.DrawTransport(g);
            pictureBox.Invalidate();
        }

        private void UpdateStatus()
        {
            if (catamaranDrawObj == null)
                return;
            
        }

        private void form_Resize(object sender, EventArgs e)
        {

            int oldWidth = pictureBox.Width;
            int oldHeight = pictureBox.Height;            
        
        }

    }
}
